import { Description } from "./Description";
import { ColumnDescription } from "./ColumnDescription";
import { SectionHeaderDescription } from "./SectionHeaderDescription";
import { RowSeparatorDescription } from "./RowSeparatorDescription";
import { HeaderSeparatorDescription } from "./HeaderSeparatorDescription";
import { ColumnResizingSeparatorDescription } from "./ColumnResizingSeparatorDescription";
import { ColumnMovingSeparatorDescription } from "./ColumnMovingSeparatorDescription";
import { GridAnimationSettingsDescription } from "./GridAnimationSettingsDescription";
import { GridCellPositionDescription } from "./GridCellPositionDescription";
import { Type } from "./type";
/**
 * @hidden
 */
export declare class LiveGridDescription extends Description {
    static $t: Type;
    private g;
    columns: ColumnDescription[];
    private cv;
    width: string;
    private cc;
    height: string;
    private be;
    background: string;
    protected get_type(): string;
    readonly type: string;
    constructor();
    private bx;
    columnResizingMode: string;
    private bt;
    columnMovingMode: string;
    private z;
    sectionHeader: SectionHeaderDescription;
    private x;
    rowSeparator: RowSeparatorDescription;
    private v;
    headerSeparator: HeaderSeparatorDescription;
    private p;
    columnResizingSeparator: ColumnResizingSeparatorDescription;
    private n;
    columnMovingSeparator: ColumnMovingSeparatorDescription;
    private h;
    dataSourceDesiredProperties: string[];
    private a4;
    rowHeight: number;
    private at;
    defaultColumnMinWidth: number;
    private a2;
    headerHeight: number;
    private b1;
    dataSourceRef: string;
    private b7;
    headerClickAction: string;
    private ab;
    autoGenerateColumns: boolean;
    private a5;
    rowSeparatorHeight: number;
    private ag;
    isPlaceholderRenderingEnabled: boolean;
    private bp;
    columnAddingAnimationMode: string;
    private bv;
    columnPropertyUpdatingAnimationMode: string;
    private bh;
    cellDataLoadedAnimationMode: string;
    private cf;
    rowSelectionAnimationMode: string;
    private bn;
    cellSelectionAnimationMode: string;
    private r;
    animationSettings: GridAnimationSettingsDescription;
    private bw;
    columnResizingAnimationMode: string;
    private b0;
    columnShowingAnimationMode: string;
    private bs;
    columnMovingAnimationMode: string;
    private br;
    columnHidingAnimationMode: string;
    private bq;
    columnExchangingAnimationMode: string;
    private cs;
    selectionMode: string;
    private bc;
    activationMode: string;
    private cr;
    selectionBehavior: string;
    private ac;
    isFilterUIEnabled: boolean;
    private ae;
    isGroupRowSticky: boolean;
    private af;
    isHeaderSeparatorVisible: boolean;
    private bm;
    cellSelectedBackground: string;
    private cl;
    sectionHeaderSelectedBackground: string;
    private au;
    pinnedRowOpacity: number;
    private cu;
    stickyRowBackground: string;
    private ce;
    pinnedRowBackground: string;
    private cd;
    lastStickyRowBackground: string;
    private t;
    activeCell: GridCellPositionDescription;
    private bf;
    cellBackground: string;
    private bo;
    cellTextColor: string;
    private b9;
    headerSortIndicatorColor: string;
    private ca;
    headerSortIndicatorStyle: string;
    private _cellFontFamily;
    cellFontFamily: string;
    private _cellFontSize;
    cellFontSize: number;
    private _cellFontStyle;
    cellFontStyle: string;
    private _cellFontWeight;
    cellFontWeight: string;
    private ck;
    sectionHeaderBackground: string;
    private cm;
    sectionHeaderTextColor: string;
    private _sectionHeaderFontFamily;
    sectionHeaderFontFamily: string;
    private _sectionHeaderFontSize;
    sectionHeaderFontSize: number;
    private _sectionHeaderFontStyle;
    sectionHeaderFontStyle: string;
    private _sectionHeaderFontWeight;
    sectionHeaderFontWeight: string;
    private a3;
    headerSeparatorWidth: number;
    private b8;
    headerSeparatorBackground: string;
    private b6;
    headerBackground: string;
    private cb;
    headerTextColor: string;
    private _headerFontFamily;
    headerFontFamily: string;
    private _headerFontSize;
    headerFontSize: number;
    private _headerFontStyle;
    headerFontStyle: string;
    private _headerFontWeight;
    headerFontWeight: string;
    private cg;
    rowSeparatorBackground: string;
    private cj;
    rowSeparatorStickyRowBackground: string;
    private ch;
    rowSeparatorLastStickyRowBackground: string;
    private ci;
    rowSeparatorPinnedRowBackground: string;
    private a1;
    columnResizingSeparatorWidth: number;
    private a0;
    columnMovingSeparatorWidth: number;
    private by;
    columnResizingSeparatorBackground: string;
    private bu;
    columnMovingSeparatorBackground: string;
    private ad;
    isGroupCollapsable: boolean;
    private b5;
    groupHeaderDisplayMode: string;
    private i;
    primaryKey: string[];
    private f;
    actualPrimaryKey: string[];
    private aj;
    reactsToSortChanges: boolean;
    private ai;
    reactsToGroupChanges: boolean;
    private ah;
    reactsToFilterChanges: boolean;
    private b3;
    filterExpressionsChangingRef: string;
    private b2;
    filterExpressionsChangedRef: string;
    private bk;
    cellPreviewPointerDownRef: string;
    private bl;
    cellPreviewPointerUpRef: string;
    private bi;
    cellPointerDownRef: string;
    private bj;
    cellPointerUpRef: string;
    private bg;
    cellClickedRef: string;
    private ct;
    sortDescriptionsChangedRef: string;
    private b4;
    groupDescriptionsChangedRef: string;
    private bz;
    columnsAutoGeneratedRef: string;
    private cp;
    selectedItemsChangedRef: string;
    private cq;
    selectedKeysChangedRef: string;
    private co;
    selectedCellsChangedRef: string;
    private bd;
    activeCellChangedRef: string;
    private cn;
    selectedCellRangesChangedRef: string;
}
