/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseDataSource } from "./BaseDataSource";
import { IPageCandidatesSink_$type } from "./IPageCandidatesSink";
import { PagePredictionEngine } from "./PagePredictionEngine";
import { LRUCache$2 } from "./LRUCache$2";
import { Base, runOn, Array_$type, Number_$type, typeCast, fromEnum, typeGetValue, String_$type, Boolean_$type, markType } from "./type";
import { IDataSourcePage_$type } from "./IDataSourcePage";
import { Dictionary$2 } from "./Dictionary$2";
import { SectionMap } from "./SectionMap";
import { DataSourceExecutionContext } from "./DataSourceExecutionContext";
import { SectionData } from "./SectionData";
import { List$1 } from "./List$1";
import { DataSourceSpecialRow } from "./DataSourceSpecialRow";
import { DataSourcePropertiesComparer } from "./DataSourcePropertiesComparer";
import { truncate, intDivide } from "./number";
/**
 * @hidden
 */
export class VirtualDataSource extends BaseDataSource {
    constructor() {
        super();
        this.b6 = null;
        this.cn = false;
        this.ch = null;
        this.ca = null;
        this.b9 = null;
        this.c3 = 50;
        this.c2 = 200;
        this.actualPageSizePopulated = false;
        this.ct = 50;
        this.cl = false;
        this.ce = null;
        this.ck = new LRUCache$2(Base.$, IDataSourcePage_$type, 0, 200);
        this.cr = new Dictionary$2(Base.$, Array_$type, 0);
        this.cs = new Dictionary$2(Number_$type, Number_$type, 0);
        this.cm = false;
        this.b4 = null;
        this.b7 = null;
        this.cj = new SectionMap();
        this.b5 = null;
        this.cy = -1;
        this.cu = -1;
        this.c0 = -1;
        this.cw = -1;
        this.c1 = -1;
        this.cx = -1;
        this.cz = -1;
        this.cv = -1;
        this.cq = new Dictionary$2(String_$type, Boolean_$type, 0);
        this.ch = new PagePredictionEngine();
        this.ch.e = this;
        this.ch.ag = this.actualPageSize;
        this.ch.f = this.cj;
        this.executionContext = new DataSourceExecutionContext();
        this.ch.b = this.executionContext;
    }
    get_actualBaseDataProvider() {
        return this.actualDataProvider;
    }
    get actualBaseDataProvider() {
        return this.get_actualBaseDataProvider();
    }
    get dataProvider() {
        return this.ca;
    }
    set dataProvider(a) {
        let b = this.ca;
        this.ca = a;
        if (b != this.ca) {
            this.onPropertyUpdated("DataProvider", b, this.ca);
        }
    }
    get actualDataProvider() {
        if (this.b9 == null) {
            this.actualDataProvider = this.resolveDataProvider();
        }
        return this.b9;
    }
    set actualDataProvider(a) {
        let b = this.b9;
        this.b9 = a;
        if (b != this.b9) {
            this.onPropertyUpdated("ActualDataProvider", b, this.b9);
        }
    }
    get pageSizeRequested() {
        return this.c3;
    }
    set pageSizeRequested(a) {
        let b = this.c3;
        this.c3 = a;
        if (b != this.c3) {
            this.onPropertyUpdated("PageSizeRequested", b, this.c3);
        }
    }
    resetCache() {
        if (this.cf != null) {
            this.cf.resetCache();
        }
        this.resetCacheOverride();
    }
    resetCacheOverride() {
        this.ck.i();
    }
    get maxCachedPages() {
        return this.c2;
    }
    set maxCachedPages(a) {
        let b = this.c2;
        this.c2 = a;
        if (b != this.c2) {
            this.onPropertyUpdated("MaxCachedPages", b, this.c2);
        }
    }
    get actualPageSize() {
        return this.ct;
    }
    set actualPageSize(a) {
        let b = this.ct;
        this.ct = a;
        if (b != this.ct) {
            this.onPropertyUpdated("ActualPageSize", b, this.ct);
        }
    }
    get_isSortingSupported() {
        if (this.o != null && !this.cl) {
            this.cl = true;
            let a = this.o.isSortingSupportedOverride;
            this.cl = false;
            return a;
        }
        return false;
    }
    get_isFilteringSupported() {
        if (this.o != null && !this.cl) {
            this.cl = true;
            let a = this.o.isFilteringSupportedOverride;
            this.cl = false;
            return a;
        }
        return false;
    }
    get_isGroupingSupported() {
        if (this.o != null && !this.cl) {
            this.cl = true;
            let a = this.o.isGroupingSupportedOverride;
            this.cl = false;
            return a;
        }
        return false;
    }
    get cf() {
        return this.ce;
    }
    set cf(a) {
        this.ce = a;
        this.actualDataProvider = this.resolveDataProvider();
    }
    resolveDataProvider() {
        if (this.cf == null) {
            return null;
        }
        return this.cf.resolveDataProvider();
    }
    propertyUpdatedOverride(a, b, c) {
        super.propertyUpdatedOverride(a, b, c);
        switch (a) {
            case "DataProvider":
                this.actualDataProvider = this.dataProvider;
                this.queueAutoRefresh();
                break;
            case "ExecutionContext":
                this.ch.b = this.executionContext;
                break;
            case "ActualDataProvider":
                this.actualDataProvider.pageSizeRequested = this.pageSizeRequested;
                this.actualDataProvider.pageLoaded = runOn(this, this.dj);
                this.queueAutoRefresh();
                break;
            case "PageSizeRequested":
                this.actualPageSize = this.pageSizeRequested;
                if (this.actualDataProvider != null) {
                    this.actualDataProvider.pageSizeRequested = this.pageSizeRequested;
                }
                this.queueAutoRefresh();
                break;
            case "ActualPageSize":
                this.ch.ag = this.actualPageSize;
                this.queueAutoRefresh();
                break;
            case "FirstVisibleIndexRequested":
                this.ch.aa = this.firstVisibleIndexRequested;
                break;
            case "LastVisibleIndexRequested":
                this.ch.ae = this.lastVisibleIndexRequested;
                break;
            case "ActualCount":
                if (this.actualDataProvider != null && !this.cj.n) {
                    this.ch.ab = this.actualDataProvider.actualCount;
                }
                else {
                    this.ch.ab = this.actualCount;
                }
                this.queueAutoRefresh();
                break;
            case "MaxCachedPages":
                this.ck.h = this.maxCachedPages;
                break;
        }
    }
    c6(a) {
        if (this.af && this.cj.n) {
            let b = this.ci(a);
            if (b == null) {
                b = this.cj.c();
            }
            return a - b.g;
        }
        return a;
    }
    dj(a, b, c) {
        let d = this.executionContext;
        if (d != null) {
            d.execute(() => this.dq(a, b, c));
        }
        else {
            this.dq(a, b, c);
        }
    }
    dq(a, b, c) {
        if (a == null) {
            b = this.resolveFullCount(b);
            if (this.actualCount != b) {
                this.actualCount = b;
            }
            return;
        }
        if (c != this.actualPageSize && !this.actualPageSizePopulated) {
            this.actualPageSize = c;
        }
        this.actualPageSizePopulated = true;
        let d = a.pageIndex();
        this.dk(d);
        this.ck.item(d, a);
        let e = a.schema();
        if (e != null) {
            this.actualSchema = e;
        }
        let f = a.getSummaryInformation();
        if (this.b7 == null && f != null) {
            this.b7 = f;
        }
        let g = a.getGroupInformation();
        if (this.b4 == null && g != null) {
            this.b4 = g;
            this.dp();
            this.cn = false;
        }
        b = this.resolveFullCount(b);
        if (this.actualCount != b) {
            this.actualCount = b;
        }
        this.dn(a);
    }
    resolveFullCount(a) {
        if (this.b4 != null) {
            return this.cj.q;
        }
        return a;
    }
    dp() {
        let a = 0;
        let b = 0;
        let c = 0;
        if (this.shouldEmitSectionHeaders) {
            switch (this.sectionHeaderDisplayMode) {
                case 0:
                    c++;
                    break;
                case 1:
                    c += this.groupDescriptions.k.count;
                    break;
            }
        }
        if (this.shouldEmitSectionFooters) {
            c++;
        }
        let d = this.shouldEmitSectionHeaders;
        let e = this.shouldEmitSectionFooters;
        for (let f = 0; f < this.b4.length; f++) {
            let g = new SectionData();
            if (d) {
                switch (this.sectionHeaderDisplayMode) {
                    case 0:
                        b++;
                        break;
                    case 1:
                        b += this.groupDescriptions.k.count;
                        break;
                }
            }
            let h = this.b4[f].endIndex - this.b4[f].startIndex;
            g.n = a;
            g.m = f;
            g.k = h + 1;
            g.l = a + h;
            g.l += c;
            g.g = b;
            g.c = this.b4[f].groupKeyProperties;
            g.d = this.b4[f].groupKeyValues;
            g.o(this.sectionHeaderDisplayMode, this.isSectionExpandedDefault);
            g.e = this.b4[f].summaryResults;
            if (e) {
                b++;
            }
            for (let i = 0; i < g.b.length; i++) {
                let j = this.df(g, i);
                g.a[i] = j;
                if (this.cq.containsKey(j)) {
                    g.b[i] = this.cq.item(j);
                }
                else {
                    g.b[i] = this.isSectionExpandedDefault;
                }
                if (!g.b[i]) {
                    let k = g.b.length - 1 - i;
                    g.l -= k;
                    b -= k;
                    if (e) {
                        b--;
                    }
                    i += k;
                }
            }
            if (!g.f) {
                g.l -= g.k;
                b -= g.k;
            }
            a = g.l + 1;
            this.cj.p.add(g);
        }
    }
    dn(a) {
        if (this.updateNotifier != null) {
            let b = a.pageIndex() * this.actualPageSize;
            if (this.actualDataProvider != null) {
                if (b > this.actualDataProvider.actualCount) {
                    return;
                }
            }
            let c = this.c5(b);
            let d = this.c5(b + a.count() - 1);
            if (c > 0 && this.getRowType(c - 1) == 1) {
                c--;
            }
            if (this.actualCount == 0 && a.count() == 0) {
                this.onClearItems();
            }
            else {
                this.updateNotifier.rangeActualized(c, d);
            }
        }
    }
    c5(a) {
        if (this.af && this.cj.n) {
            let b = this.cj.f(a);
            if (b == null) {
                b = this.cj.c();
            }
            if (!b.f) {
                return b.n;
            }
            return a + b.g;
        }
        return a;
    }
    dl(a) {
        a();
    }
    get_isVirtual() {
        return true;
    }
    isPlaceholderItem(a) {
        let b = this.b8(a);
        let c = b[0];
        if (!this.ck.d(c)) {
            return true;
        }
        return false;
    }
    getItemAtIndex(a) {
        let b = this.b8(a);
        let c = b[0];
        if (!this.ck.d(c)) {
            if (b[1] == -1) {
                return this.da(a);
            }
            return null;
        }
        let d = this.ck.item(c);
        let e = b[1];
        if (e == -1) {
            return this.da(a);
        }
        return d.getItemAtIndex(e);
    }
    da(a) {
        let b = this.ci(a);
        if (a >= b.n && a < b.n + b.b.length) {
            let c = a - b.n;
            let d = new DataSourceSpecialRow();
            d.rowType = 1;
            d.level = c;
            d.summaryResults = b.e;
            if (this.sectionHeaderDisplayMode == 0) {
                for (let e = 0; e < this.groupDescriptions.k.count; e++) {
                    d.setSectionValue(this.groupDescriptions.k.item(e).propertyName, b.d[e]);
                }
            }
            else {
                d.setSectionValue(this.groupDescriptions.k.item(c).propertyName, b.d[c]);
            }
            return d;
        }
        if (a == b.l) {
            let f = new DataSourceSpecialRow();
            f.rowType = 2;
            for (let g = 0; g < this.groupDescriptions.k.count; g++) {
                f.setSectionValue(this.groupDescriptions.k.item(g).propertyName, b.d[g]);
            }
            return f;
        }
        return null;
    }
    b8(a) {
        if (this.af && this.cj.n) {
            let b = this.ci(a);
            if (b == null) {
                b = this.cj.c();
            }
            let c = b.n;
            let d = false;
            if (a >= c && a < c + b.b.length && this.shouldEmitSectionHeaders) {
                d = true;
            }
            if (a - (c + b.b.length - 1) <= b.h) {
                d = true;
            }
            let e = a - b.g;
            let f = truncate(Math.floor(e / this.actualPageSize));
            let g = e % this.actualPageSize;
            if (d) {
                g = -1;
            }
            let h = new Array(2);
            h[0] = f;
            h[1] = g;
            return h;
        }
        else {
            let i = truncate(Math.floor(a / this.actualPageSize));
            let j = a % this.actualPageSize;
            let k = new Array(2);
            k[0] = i;
            k[1] = j;
            return k;
        }
    }
    ci(a) {
        return this.cj.d(a);
    }
    getItemPropertyAtIndex(a, b) {
        let c = this.b8(a);
        let d = c[0];
        if (!this.ck.d(d)) {
            if (c[1] == -1) {
                return this.db(a, b);
            }
            return null;
        }
        let e = this.ck.item(d);
        let f = c[1];
        if (f == -1) {
            return this.db(a, b);
        }
        return e.getItemValueAtIndex(f, b);
    }
    db(a, b) {
        let c = this.da(a);
        if (typeCast(DataSourceSpecialRow.$, c) !== null) {
            return c.getValue(b);
        }
        return null;
    }
    dm(a) {
        if (!this.cs.containsKey(a)) {
            this.cs.addItem(a, 1);
        }
        else {
            this.cs.item(a, this.cs.item(a) + 1);
        }
    }
    dk(a) {
        if (this.cs.containsKey(a)) {
            this.cs.item(a, this.cs.item(a) - 1);
            if (this.cs.item(a) <= 0) {
                this.cs.removeItem(a);
                if (this.actualDataProvider != null) {
                    this.actualDataProvider.removePageRequest(a);
                }
            }
        }
    }
    addCandidate(a, b) {
        let c = false;
        if (!this.cr.containsKey(a)) {
            let d = new List$1(Number_$type, 0);
            let e = this.transformPage(a);
            for (let f = 0; f < e.length; f++) {
                let g = e[f];
                if (!this.ck.d(g)) {
                    d.add(g);
                    this.dm(g);
                    let h = this.cs.item(g);
                    if (h == 1 && this.actualDataProvider != null) {
                        this.actualDataProvider.addPageRequest(g, b);
                    }
                    c = true;
                }
            }
            if (d.count > 0) {
                this.cr.addItem(a, d.toArray());
            }
        }
        return c;
    }
    removeCandidate(a) {
        if (this.cr.containsKey(a)) {
            for (let b = 0; b < this.cr.item(a).length; b++) {
                let c = this.cr.item(a)[b];
                this.dk(c);
            }
            this.cr.removeItem(a);
        }
    }
    transformPage(a) {
        let b = [a];
        if (this.af && this.cj.n) {
            let c = a * this.actualPageSize;
            let d = c + this.actualPageSize - 1;
            let e = this.ci(c);
            let f = new List$1(Number_$type, 0);
            for (let g = c; g <= d; g++) {
                if (e == null) {
                    break;
                }
                if (g > e.l) {
                    if (e.m < this.cj.p.count - 1) {
                        e = this.cj.p._inner[e.m + 1];
                    }
                    else {
                        break;
                    }
                }
                if (!e.f || (g >= e.n && g <= e.n + (e.b.length - 1) + e.h)) {
                    continue;
                }
                let h = g - e.g;
                let i = intDivide(h, this.actualPageSize);
                if (!f.contains(i)) {
                    f.add(i);
                }
            }
            b = f.toArray();
        }
        return b;
    }
    getUnrealizedCount() {
        let a = this.ck.g * this.actualPageSize;
        let b = this.actualCount - a;
        return b;
    }
    onSetItemOverride(a, b, c) {
        super.onSetItemOverride(a, b, c);
        let d = this.b8(a);
        let e = d[0];
        if (this.ck.d(e)) {
            this.ck.j(e);
        }
    }
    refreshInternalOverride() {
        super.refreshInternalOverride();
        this.actualPageSizePopulated = false;
        let a = this.actualCount != 0;
        this.cm = true;
        if (!this.cn) {
            this.resetCache();
            if (a) {
                this.onClearItems();
            }
            this.b4 = null;
            this.cj.r();
        }
        else {
            this.cn = false;
            if (a) {
                this.onClearItems();
            }
        }
        this.dr();
        this.ch.au();
        this.cm = false;
    }
    dr() {
        if (this.actualDataProvider != null) {
            for (let a of fromEnum(this.cr.values)) {
                for (let c = 0; c < a.length; c++) {
                    let b = a[c];
                    this.actualDataProvider.addPageRequest(b, 1);
                }
            }
        }
    }
    onClearItemsOverride() {
        super.onClearItemsOverride();
        if (!this.cm) {
            this.queueAutoRefresh();
        }
    }
    onInsertItemOverride(a, b) {
        super.onInsertItemOverride(a, b);
        this.queueAutoRefresh();
    }
    onRemoveItemOverride(a, b) {
        super.onRemoveItemOverride(a, b);
        this.queueAutoRefresh();
    }
    get_isItemIndexLookupSupported() {
        return true;
    }
    get_isKeyIndexLookupSupported() {
        return true;
    }
    indexOfItem(a) {
        let b = this.ck.b;
        let c = b.o;
        let d = b.q;
        let e = d.count;
        let f = b.p;
        for (let g = 0; g < e; g++) {
            if (f._inner[g]) {
                continue;
            }
            let h = d._inner[g].b;
            let i = h.count();
            for (let j = 0; j < i; j++) {
                if (this.cp(h.getItemAtIndex(j), a)) {
                    let k = typeGetValue(c._inner[g]);
                    let l = k * this.actualPageSize;
                    return l + j;
                }
            }
        }
        if (this.actualDataProvider != null && this.actualDataProvider.isItemIndexLookupSupported) {
            return this.actualDataProvider.indexOfItem(a);
        }
        return -1;
    }
    cp(a, b) {
        if (a == null && b == null) {
            return true;
        }
        if (a == null || b == null) {
            return false;
        }
        return Base.equalsStatic(a, b);
    }
    indexOfKey(a) {
        let b = this.actualPrimaryKey;
        if (b == null || b.length < 1 || this.actualBaseDataProvider == null) {
            return -1;
        }
        this.ensureComparables(this.actualSchema);
        let c = this.cg();
        let d = this.ck.b;
        let e = d.o;
        let f = d.q;
        let g = f.count;
        let h = d.p;
        for (let i = 0; i < g; i++) {
            if (h._inner[i]) {
                continue;
            }
            let j = f._inner[i].b;
            let k = j.count();
            for (let l = 0; l < k; l++) {
                if (c.i(j.getItemAtIndex(l), a) == 0) {
                    let m = typeGetValue(e._inner[i]);
                    let n = m * this.actualPageSize;
                    return n + l;
                }
            }
        }
        if (this.actualDataProvider != null && this.actualDataProvider.isKeyIndexLookupSupported) {
            return this.actualDataProvider.indexOfKey(a);
        }
        return -1;
    }
    cg() {
        let a = new Array(this.actualPrimaryKey.length);
        for (let b = 0; b < a.length; b++) {
            a[b] = 0;
        }
        return new DataSourcePropertiesComparer(this.actualPrimaryKey, a, this.b6, this);
    }
    getStickyRowPriority(a) {
        if (this.getRowType(a) == 1 || this.getRowType(a) == 2) {
            return 100 - this.getRowLevel(a);
        }
        else if (this.getRowType(a) == 3) {
            return 2;
        }
        return 1;
    }
    unpinRow(a) {
        super.unpinRow(a);
    }
    pinRow(a) {
        super.pinRow(a);
    }
    isRowPinned(a) {
        return super.isRowPinned(a);
    }
    getStickyRowsInRange(a, b) {
        if (this.groupDescriptions == null || this.groupDescriptions.k.count == 0) {
            return null;
        }
        let c = this.ci(a);
        let d = this.ci(b);
        if (c == null || d == null) {
            return null;
        }
        if (c.m == this.cy && c.h == this.c0 && c.n == this.c1 && c.l == this.cz && d.m == this.cu && d.h == this.cw && d.n == this.cx && d.l == this.cv) {
            return this.b5;
        }
        this.cy = c.m;
        this.cu = d.m;
        this.c0 = c.h;
        this.cw = d.h;
        this.c1 = c.n;
        this.cx = d.n;
        this.cz = c.l;
        this.cv = d.l;
        let e = new List$1(Number_$type, 0);
        for (let f = c.m; f <= d.m; f++) {
            let g = this.cj.p._inner[f];
            if (this.shouldEmitSectionHeaders && this.af) {
                for (let h = 0; h < g.b.length; h++) {
                    e.add(g.n + h);
                    if (!g.b[h]) {
                        break;
                    }
                }
            }
            if (this.shouldEmitShiftedRows) {
                let i = g.b.length;
                for (let j = 0; j < g.h; j++) {
                    e.add(g.n + j + i);
                }
            }
            if (this.shouldEmitSectionFooters && this.af) {
                for (let k = g.b.length - 1; k >= 0; k--) {
                    if (!g.b[k]) {
                        break;
                    }
                    e.add(g.l - k);
                }
            }
        }
        this.b5 = e.toArray();
        return this.b5;
    }
    isExclusivelySticky(a) {
        return this.getRowType(a) == 1 || this.getRowType(a) == 2;
    }
    getRowType(a) {
        if (a < 0) {
            return 0;
        }
        let b = this.getItemAtIndex(a);
        let item_ = b;
        if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
            return b.rowType;
        }
        return 0;
    }
    getIsRowExpandedAtIndex(a) {
        let b = this.cj.d(a);
        if (b == null) {
            b = this.cj.c();
        }
        for (let c = 0; c < b.b.length; c++) {
            if (a == b.n + c) {
                return b.b[c];
            }
        }
        return super.getIsRowExpandedAtIndex(a);
    }
    setIsRowExpandedAtIndex(a, b) {
        let c = this.cj.d(a);
        if (c == null) {
            c = this.cj.c();
        }
        for (let d = 0; d < c.b.length; d++) {
            if (a == c.n + d) {
                let e = false;
                let f = c.a[d];
                if (this.cq.containsKey(f) && this.cq.item(f) != b) {
                    if (b == this.isSectionExpandedDefault) {
                        this.cq.removeItem(f);
                    }
                    else {
                        this.cq.item(f, b);
                    }
                    e = true;
                }
                else if (b != this.isSectionExpandedDefault) {
                    this.cq.addItem(f, b);
                    e = true;
                }
                if (e) {
                    this.cj.r();
                    this.dp();
                    this.cn = true;
                    this.actualCount = this.cj.q;
                }
                break;
            }
        }
    }
    getRowLevel(a) {
        if (a < 0) {
            return 0;
        }
        let b = this.getItemAtIndex(a);
        let item_ = b;
        if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
            return b.level;
        }
        return 0;
    }
    de(a) {
        let b = "";
        for (let c = 0; c < a.c.length; c++) {
            b += a.c[c] + ":" + a.d[c];
        }
        return b;
    }
    df(a, b) {
        if (this.sectionHeaderDisplayMode == 0) {
            return this.de(a);
        }
        let c = "";
        for (let d = 0; d < a.c.length; d++) {
            c += a.c[d] + ":" + a.d[d] + ":";
        }
        c += b;
        return c;
    }
}
VirtualDataSource.$t = markType(VirtualDataSource, 'VirtualDataSource', BaseDataSource.$, [IPageCandidatesSink_$type]);
